%{!?python2_sitearch: %define python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%define with_ocaml 0
%define build_ocaml 0
%define with_xsm 0
%define build_xsm 0
# cross compile 64-bit hypervisor on ix86 unless rpmbuild was run
# with --without crosshyp
%define build_crosshyp %{?_without_crosshyp: 0} %{?!_without_crosshyp: 1}
%ifnarch %{ix86}
%define build_crosshyp 0
%define build_hyp 1
%else
%if %build_crosshyp
%define build_hyp 1
%else
%define build_hyp 0
# no point in trying to build xsm on ix86 without a hypervisor
%define build_xsm 0
%endif
%endif
# build an efi boot image (where supported) unless rpmbuild was run with
# --without efi
%define build_efi %{?_without_efi: 0} %{?!_without_efi: 1}
# xen only supports efi boot images on x86_64
%ifnarch x86_64
%define build_efi 0
%endif
%if 0%{?rhel} == 7
%define build_efi 0
%endif
%define with_python2 1
%define with_python3 1

%define _missing_build_ids_terminate_build 0

# Hypervisor ABI
%define hv_abi 4.8

Summary: Xen is a virtual machine monitor
Name:    xen
Version: 4.8.5
Release: 42%{?dist}
Epoch:   2001
Group:   Development/Libraries
License: GPLv2+ and LGPLv2+ and BSD
URL:     http://xen.org/
Source0: xen-%{version}.tar.gz
Source2: %{name}.logrotate
Source3: config
# used by stubdoms
Source10: lwip-1.3.0.tar.gz
Source11: newlib-1.16.0.tar.gz
Source12: zlib-1.2.3.tar.gz
Source13: pciutils-2.2.9.tar.bz2
Source14: grub-0.97.tar.gz
Source15: gmp-4.3.2.tar.bz2
Source16: polarssl-1.1.4-gpl.tgz
Source18: tpm_emulator-0.7.4.tar.gz
Source32: xen.modules-load.conf

# Qubes components for stubdom
Source33: gui-agent-xen-hvm-stubdom-5f57a59.tar.gz
Source34: core-vchan-xen-42d07fb.tar.gz
Source35: stubdom-dhcp-7593a9d.tar.gz
Source36: gui-common-c611481.tar.gz

# Out-of-tree patches.
#
# Use the following patch numbers:
# 100+:  Fedora
# 200+:  EFI workarounds
# 300+:  Backports
# 400+:  PVH backports
# 500+:  Security fixes
# 600+:  Upstreamable patches
# 700+:  GCC7+ fixes
# 800+:  vchan for stubdom
# 900+:  Qubes specific patches
# 1000+: python3
# 1100+: Support for Linux based stubdom
# 1200+: Other

# Fedora
Patch101: patch-xen.use.fedora.ipxe.patch
Patch102: patch-xen.fedora.efi.build.patch
Patch103: patch-xen.gcc5.fix.patch
Patch104: patch-xen.vwprintw.fix.patch
Patch105: patch-xen.gcc11.fixes.patch

# EFI workarounds

Patch201: patch-0001-EFI-early-Add-noexit-to-inhibit-calling-ExitBootServices.patch
Patch202: patch-0002-efi-Ensure-incorrectly-typed-runtime-services-get-ma.patch
Patch203: patch-0001-Add-xen.cfg-options-for-mapbs-and-noexitboot.patch

# Backports
Patch301: patch-0001-libxl-add-more-cpuid-flags-handling.patch
Patch302: patch-libxc-panic-when-trying-to-create-a-PVH-guest-withou.patch
Patch303: patch-b4f98dc0-tools-fix-typo-in-tools-Rules.mk.patch
Patch304: patch-448c03b3-tools-xenstore-try-to-get-minimum-thread-stack-size-.patch
Patch305: patch-c9bd8a73-tools-xenstore-add-libdl-dependency-to-libxenstore.patch
Patch306: patch-1a373194-tools-xenstore-fix-linking-libxenstore-with-ldl.patch
Patch307: patch-xen-AMD-IOMMU-Support-IOAPIC-IDs-larger-than-128.patch
Patch308: patch-0001-libxl-devd-fix-a-race-with-concurrent-device-additio.patch
Patch309: patch-0002-libxl-devd-correctly-manipulate-the-dguest-list.patch
Patch310: patch-0011-x86-vmx-fix-vmentry-failure-with-TSX-bits-in-LBR.patch
Patch311: patch-0012-x86-vmx-Fix-vmentry-failure-because-of-invalid-LER-o.patch
Patch312: patch-0013-x86-vtx-Corrections-to-BDF93-errata-workaround.patch
Patch313: patch-0014-x86-vtx-Fixes-to-Haswell-Broadwell-LBR-TSX-errata.patch
Patch314: patch-0015-VT-x-extend-LBR-Broadwell-errata-coverage.patch
Patch315: patch-0001-x86-hvm-make-io.h-self-contained.patch
Patch316: patch-0002-passthrough-don-t-migrate-pirq-when-it-is-delivered-.patch
Patch317: patch-0003-VT-d-introduce-new-fields-in-msi_desc-to-track-bindi.patch
Patch318: patch-0004-VT-d-some-cleanups.patch
Patch319: patch-0005-VT-d-introduce-update_irte-to-update-irte-safely.patch
Patch320: patch-0001-xen-sched-call-cpu_disable_scheduler-via-cpu-notifie.patch
Patch321: patch-0002-xen-add-helper-for-calling-notifier_call_chain-to-co.patch
Patch322: patch-0003-xen-add-new-cpu-notifier-action-CPU_RESUME_FAILED.patch
Patch323: patch-0004-xen-don-t-free-percpu-areas-during-suspend.patch
Patch324: patch-0005-xen-cpupool-simplify-suspend-resume-handling.patch
Patch325: patch-0006-x86-ACPI-re-park-previously-parked-CPUs-upon-resume-.patch
Patch326: patch-0007-sched-populate-cpupool0-only-after-all-cpus-are-up.patch
Patch327: patch-0008-x86-clear-per-cpu-stub-page-information-in-cpu_smpbo.patch
Patch328: patch-0009-x86-S3-put-data-segment-registers-into-known-state-u.patch
Patch329: patch-0001-tools-xenstore-fix-a-use-after-free-problem-in-xenst.patch
Patch330: patch-0001-xenstore-modify-add_change_node-parameter-types.patch
Patch331: patch-0002-xenstore-call-add_change_node-directly-when-writing-.patch
Patch332: patch-0003-xenstore-use-common-tdb-record-header-in-xenstore.patch
Patch333: patch-0004-xenstore-add-per-node-generation-counter.patch
Patch334: patch-0005-xenstore-add-support-for-reading-directory-with-many.patch
Patch335: patch-0006-xenstore-support-XS_DIRECTORY_PART-in-libxenstore.patch
Patch336: patch-0007-xenstore-use-array-for-xenstore-wire-command-handlin.patch
Patch337: patch-0008-xenstore-let-command-functions-return-error-or-succe.patch
Patch338: patch-0009-xenstore-make-functions-static.patch
Patch339: patch-0010-xenstore-add-helper-functions-for-wire-argument-pars.patch
Patch340: patch-0011-xenstore-add-small-default-data-buffer-to-internal-s.patch
Patch341: patch-0012-xenstore-handle-memory-allocation-failures-in-xensto.patch
Patch342: patch-0013-tools-xenstore-avoid-unterminated-string-in-xs_direc.patch
Patch343: patch-0014-xenstore-set-correct-error-code-when-violating-quota.patch
Patch344: patch-0015-xenstore-remove-XS_RESTRICT-support.patch
Patch345: patch-0016-xenstore-correct-test-for-opened-logfile-in-reopen_l.patch
Patch346: patch-0017-xenstore-rename-XS_DEBUG-wire-command.patch
Patch347: patch-0018-xenstore-Split-out-XS_CONTROL-action-to-dedicated-so.patch
Patch348: patch-0019-tools-xenstore-start-with-empty-data-base.patch
Patch349: patch-0020-xenstored-remove-L-option.patch
Patch350: patch-0021-xenstore-remove-memory-report-command-line-support.patch
Patch351: patch-0022-xenstore-add-missing-checks-for-allocation-failure.patch
Patch352: patch-0023-xenstore-let-write_node-and-some-callers-return-errn.patch
Patch353: patch-0024-xenstore-undo-function-rename.patch
Patch354: patch-0025-xenstore-rework-of-transaction-handling.patch
Patch355: patch-0001-x86-atomic-fix-cmpxchg16b-inline-assembly-to-work-wi.patch
Patch356: patch-0001-x86-atomic-Improvements-and-simplifications-to-assem.patch
Patch357: patch-0001-crypto-adjust-rijndaelEncrypt-prototype-for-gcc11.patch
Patch358: patch-0001-x86-vtd-Don-t-include-control-register-state-in-the-.patch
Patch359: patch-0001-passthrough-vtd-Don-t-DMA-to-the-stack-in-queue_inva.patch
Patch361: patch-xen-access-once.patch
Patch362: patch-0001-nospec-introduce-evaluate_nospec.patch
Patch363: patch-x86-PoD-correctly-handle-non-order-0-decrease-reserv.patch
Patch364: patch-VT-d-don-t-pass-bridge-devices-to-domain_context_map.patch
Patch365: patch-x86-page--Rename-PAGE_HYPERVISOR_NOCACHE-to-PAGE_HYPE.patch
Patch366: patch-x86-page--Introduce-and-use-PAGE_HYPERVISOR_UC.patch
Patch367: patch-x86-limit-page-type-width.patch
Patch368: patch-x86-cpufeatures-Expose-self-snoop-to-all-guests.patch
Patch369: patch-x86-cpu-intel-Clear-cache-self-snoop-capability-in-C.patch

# PVH backports
Patch401: patch-88e43f9a-acpi-make-pmtimer-optional-in-FADT.patch
Patch402: patch-b5419306-acpi-power-and-sleep-ACPI-buttons-are-not-emulated-f.patch
Patch403: patch-aff79e7a-acpi-PVH-guests-need-_E02-method.patch
Patch404: patch-3b7a1b85-libacpi-add-_FADT_-to-the-FADT-boot-flags-definition.patch
Patch405: patch-3031b10e-libacpi-set-FADT-boot-flag-to-notify-lack-of-VGA-for.patch
Patch406: patch-4604e0b5-libacpi-don-t-announce-a-8042-controller-in-the-FADT.patch
Patch407: patch-c281cd3b-libacpi-update-FADT-layout-to-support-version-5.patch
Patch408: patch-9f7fea37-libacpi-announce-that-PVHv2-has-no-CMOS-RTC-in-FADT.patch
Patch409: patch-9a70679d-firmware-rombios-fix-after-update-to-libacpi.patch
Patch410: patch-666a1ded-x86-pmtimer-move-ACPI-registers-from-PMTState-to-hvm.patch
Patch411: patch-4dbaa654-libxl-Update-xenstore-on-VCPU-hotplug-for-all-guest-.patch
Patch412: patch-ea9e7fd9-libxl-add-is_default-checkers-for-string-and-timer_m.patch
Patch413: patch-5eee1677-xl-parsing-code-movement.patch
Patch414: patch-84238f2f-libxl-pvh-Add-accessor-macros-for-domain-type-and-ve.patch
Patch415: patch-f41fd2fe-libxl-pvh-Use-accessor-macros-internally.patch
Patch416: patch-ce297088-xl-pvh-Use-accessor-macros.patch
Patch417: patch-23adea59-MAYBE-FIX-libxl-xl-use-the-new-location-of-domain_bu.patch
Patch418: patch-3c717179-xl-introduce-a-domain-type-option.patch
Patch419: patch-46985bb4-xl-introduce-a-firmware-option.patch
Patch420: patch-ded8f147-libxl-don-t-segfault-when-creating-domain-with-inval.patch
Patch421: patch-e8fbb1fa-libxl-introduce-a-PVH-guest-type.patch
Patch422: patch-9cbd5666-libxl-allow-PVH-guests-to-use-a-bootloader.patch
Patch423: patch-556bb771-libxl-set-PVH-guests-to-use-the-PV-console.patch
Patch424: patch-b2a9d4ab-libxl-add-PVH-support-to-domain-creation.patch
Patch425: patch-95fa85ce-libxl-remove-device-model-none-support-from-disk-rel.patch
Patch426: patch-6f766694-libxl-set-device-model-for-PVH-guests.patch
Patch427: patch-35d9650f-libxl-add-PVH-support-to-domain-building.patch
Patch428: patch-040057b2-libxl-add-PVH-support-to-domain-save-suspend.patch
Patch429: patch-dfcd6be8-libxl-add-PVH-support-to-vpcu-hotplug-domain-destruc.patch
Patch430: patch-1716a61c-libxl-add-PVH-support-to-memory-functions.patch
Patch431: patch-98733e66-libxl-PVH-guests-use-PV-nics.patch
Patch432: patch-f3792730-libxl-remove-device-model-none-support-from-stream-f.patch
Patch433: patch-1c0771fc-libxl-add-PVH-support-to-USB.patch
Patch434: patch-b6a0564b-libxl-add-PVH-support-to-x86-functions.patch
Patch435: patch-0f1d3c78-xl-add-PVH-as-a-guest-type.patch
Patch436: patch-6d1a9bcb-libxl-remove-device-model-none-from-IDL.patch
Patch437: patch-60efd677-xl-Don-t-warn-on-using-deprecated-mode-selection.patch

Patch438: patch-x86-check-feature-flags-after-resume.patch
Patch439: patch-2dd3e22949-tools-libelf-fix-elf-notes-check-for-PVH-guest.patch

Patch440: patch-xl-pvh-fixups.patch

# Security fixes
Patch500: patch-xsa284.patch
Patch501: patch-xsa285-4.11.patch
Patch502: patch-xsa287-4.8.patch
Patch503: patch-xsa288-4.8.patch
Patch504: patch-xsa290-4.8-1.patch
Patch505: patch-xsa290-4.8-2.patch
Patch506: patch-xsa291-4.9.patch
Patch507: patch-xsa292.patch
Patch508: patch-xsa293-4.8-1.patch
Patch509: patch-xsa293-4.8-2.patch
Patch510: patch-xsa293-4.8-3.patch
Patch511: patch-xsa297-4.8-1.patch
Patch512: patch-xsa297-4.8-2.patch
Patch513: patch-xsa297-4.8-3.patch
Patch514: patch-xsa297-4.8-4.patch
Patch515: patch-xsa297-4.8-5.patch
Patch516: patch-xsa297-4.8-6.patch
Patch517: patch-xsa297-4.8-7.patch
Patch518: patch-xsa297-4.8-8.patch
Patch519: patch-xsa299-0001-x86-mm-Clean-up-trailing-whitespace.patch
Patch520: patch-xsa299-0002-x86-mm-L1TF-checks-don-t-leave-a-partial-entry.patch
Patch521: patch-xsa299-0003-x86-mm-Don-t-re-set-PGT_pinned-on-a-partially-de-val.patch
Patch522: patch-xsa299-0004-x86-mm-Separate-out-partial_pte-tristate-into-indivi.patch
Patch523: patch-xsa299-0005-x86-mm-Use-flags-for-_put_page_type-rather-than-a-bo.patch
Patch524: patch-xsa299-0006-x86-mm-Rework-get_page_and_type_from_mfn-conditional.patch
Patch525: patch-xsa299-0007-x86-mm-Have-alloc_l-23-_table-clear-partial_flags-wh.patch
Patch526: patch-xsa299-0008-x86-mm-Always-retain-a-general-ref-on-partial.patch
Patch527: patch-xsa299-0009-x86-mm-Collapse-PTF_partial_set-and-PTF_partial_gene.patch
Patch528: patch-xsa299-0010-x86-mm-Properly-handle-linear-pagetable-promotion-fa.patch
Patch529: patch-xsa299-0011-x86-mm-Fix-nested-de-validation-on-error.patch
Patch530: patch-xsa299-0012-x86-mm-Don-t-drop-a-type-ref-unless-you-held-a-ref-t.patch
Patch531: patch-xsa302-0001-IOMMU-add-missing-HVM-check.patch
Patch532: patch-xsa302-0002-passthrough-quarantine-PCI-devices.patch
Patch533: patch-xsa305-4.8-1.patch
Patch534: patch-xsa305-4.8-2.patch
Patch535: patch-xsa306-4.9.patch
Patch536: patch-xsa310-4.9-0001-x86-mm-Set-old_guest_table-when-destroying-vcpu-page.patch
Patch537: patch-xsa310-4.9-0002-x86-mm-alloc-free_lN_table-Retain-partial_flags-on-E.patch
Patch538: patch-xsa310-4.9-0003-x86-mm-relinquish_memory-Grab-an-extra-type-ref-when.patch
Patch539: patch-xsa311-4.8-1.patch
Patch540: patch-xsa311-4.8-2.patch
# the ordering is intentional - XSA-328 is a dependency of XSA-321
Patch541: patch-xsa328-4.9-1.patch
Patch542: patch-xsa328-4.9-2.patch
Patch543: patch-xsa321-4.9-1.patch
Patch544: patch-xsa321-4.9-2.patch
Patch545: patch-xsa321-4.9-3.patch
Patch546: patch-xsa321-4.9-4.patch
Patch547: patch-xsa321-4.9-5.patch
Patch548: patch-xsa321-4.9-6.patch
Patch549: patch-xsa321-4.9-7.patch
Patch550: patch-xsa337-4.8-1.patch
Patch551: patch-xsa337-4.8-2.patch
Patch552: patch-xsa340-4.8.patch
Patch553: patch-xsa343-4.8-1.patch
Patch554: patch-xsa343-4.8-2.patch
Patch555: patch-xsa343-4.8-3.patch
Patch556: patch-xsa345-4.10-0001-x86-mm-Refactor-map_pages_to_xen-to-have-only-a-sing.patch
Patch557: patch-xsa345-4.10-0002-x86-mm-Refactor-modify_xen_mappings-to-have-one-exit.patch
Patch558: patch-xsa345-4.10-0003-x86-mm-Prevent-some-races-in-hypervisor-mapping-upda.patch
Patch559: patch-xsa346-4.10-1.patch
Patch560: patch-xsa346-4.10-2.patch
Patch561: patch-xsa347-4.11-1.patch
Patch562: patch-xsa347-4.11-2.patch
Patch563: patch-xsa351-x86-4.8-1.patch
Patch564: patch-xsa351-x86-4.8-2.patch
Patch565: patch-xsa355.patch
Patch566: patch-xsa115-0001-tools-xenstore-allow-removing-child-of-a-node-exceed.patch
Patch567: patch-xsa115-0002-tools-xenstore-ignore-transaction-id-for-un-watch.patch
Patch568: patch-xsa115-0003-tools-xenstore-fix-node-accounting-after-failed-node.patch
Patch569: patch-xsa115-0004-tools-xenstore-simplify-and-rename-check_event_node.patch
Patch570: patch-xsa115-0005-tools-xenstore-check-privilege-for-XS_IS_DOMAIN_INTR.patch
Patch571: patch-xsa115-0006-tools-xenstore-rework-node-removal.patch
Patch572: patch-xsa115-0007-tools-xenstore-fire-watches-only-when-removing-a-spe.patch
Patch573: patch-xsa115-0008-tools-xenstore-introduce-node_perms-structure.patch
Patch574: patch-xsa115-0009-tools-xenstore-allow-special-watches-for-privileged-.patch
Patch575: patch-xsa115-0010-tools-xenstore-avoid-watch-events-for-nodes-without-.patch
Patch576: patch-xsa325-4.14.patch
Patch577: patch-xsa366-4.11.patch
Patch578: patch-xsa373-4.11-1.patch
Patch579: patch-xsa373-4.11-2.patch
Patch580: patch-xsa373-4.11-3.patch
Patch581: patch-xsa373-4.11-4.patch
Patch582: patch-xsa373-4.11-5.patch
Patch583: patch-xsa375-4.8.patch
Patch584: patch-xsa377-4.11.patch
# dependencies for XSA-378, but applied on top of patches for XSA-302
Patch585: patch-x86-iommu-set-up-a-scratch-page-in-the-quarantine-do.patch
Patch586: patch-AMD-IOMMU-fix-off-by-one-in-amd_iommu_get_paging_mod.patch
Patch587: patch-xsa378-4.11-0a.patch
Patch588: patch-xsa378-4.11-0b.patch
Patch589: patch-xsa378-4.11-0c.patch
Patch590: patch-xsa378-4.11-1.patch
Patch591: patch-xsa378-4.11-2.patch
Patch592: patch-xsa378-4.11-3.patch
Patch593: patch-xsa378-4.11-4.patch
Patch594: patch-xsa378-4.11-5.patch
Patch595: patch-xsa378-4.11-6.patch
Patch596: patch-xsa378-4.11-7.patch
Patch597: patch-xsa378-4.11-8.patch
Patch598: patch-xsa379-4.12.patch
Patch599: patch-xsa388-4.8-1.patch
Patch600: patch-xsa388-4.8-2.patch
Patch601: patch-xsa389-4.8.patch
Patch602: patch-xsa395-4.14.patch
Patch603: patch-xsa398-4.8-6.patch
Patch604: patch-xsa399-4.12.patch
Patch605: patch-xsa400-4.8-00.patch
Patch606: patch-xsa400-4.8-01.patch
Patch607: patch-xsa400-4.8-02.patch
Patch608: patch-xsa400-4.8-03.patch
Patch609: patch-xsa400-4.8-04.patch
Patch610: patch-xsa400-4.8-05.patch
Patch611: patch-xsa400-4.8-06.patch
Patch612: patch-xsa400-4.8-07.patch
Patch613: patch-xsa400-4.8-08.patch
Patch614: patch-xsa400-4.8-09.patch
Patch615: patch-xsa400-4.8-10.patch
Patch616: patch-xsa400-4.8-11.patch
Patch617: patch-xsa309.patch
Patch618: patch-xsa401-4.8-1.patch
Patch619: patch-xsa401-4.8-2.patch
Patch620: patch-xsa402-4.8-1.patch
Patch621: patch-xsa402-4.8-2.patch
Patch622: patch-xsa402-4.8-3.patch
Patch623: patch-xsa402-4.8-4.patch
Patch624: patch-xsa402-4.8-5.patch
# dependencies for XSA-404
Patch625: patch-xsa320-4.8-1.patch
Patch626: patch-xsa320-4.8-2.patch
Patch627: patch-xsa320-4.8-3.patch
Patch628: patch-x86-spec-ctrl-Clean-up-MSR_MCU_OPT_CTRL-handling.patch
Patch629: patch-xsa404-4.8-1.patch
Patch630: patch-xsa404-4.8-2.patch
Patch631: patch-xsa404-4.8-3.patch
Patch632: patch-xsa403-4.8-1.patch
Patch633: patch-xsa403-4.8-trusted-dom0.patch

# Upstreamable patches
Patch651: patch-xen-libxl-error-write-perm.patch
Patch652: patch-xen-xl-create-quiet.patch
#Patch653: patch-libxl-make-nic-bridge-parameter-optional-do-not-fill.patch
Patch654: patch-libxl-Revert-libxl-Remove-redundant-setting-of-phyical-dev.patch
Patch655: patch-libxl-allow-PHY-backend-for-files-allocate-loop-devi.patch
Patch656: patch-libxl-do-not-call-default-block-script.patch
Patch657: patch-libxl-do-not-for-backend-on-PCI-remove-when-backend-.patch
Patch658: patch-libxl-fix-libxl_device_-_remove-with-driver-domain-s.patch
Patch659: patch-libxl-suspend.patch
Patch660: patch-stubdom-gmp-compile-fix.patch
Patch661: patch-0001-libxl-attach-xen-pciback-only-to-PV-domains.patch
Patch662: patch-0002-libxl-attach-PCI-device-to-qemu-only-after-setting-p.patch
Patch663: patch-0003-libxl-don-t-try-to-manipulate-json-config-for-stubdo.patch
Patch664: patch-0001-libxl-do-not-fail-device-removal-if-backend-domain-i.patch
Patch665: patch-hvmpt01-minios-exprom-size.patch
Patch666: patch-hvmpt02-disable-msix-caps.patch
Patch667: patch-hvmpt03-passthrough-log.patch
Patch668: patch-hvmpt04-minios-nomask-bar-addrs.patch
Patch669: patch-hvmpt05-hide-pio-bars.patch
Patch670: patch-hvmpt06-fix-msix.patch
Patch671: patch-libxc-fix-xc_gntshr_munmap-semantic.patch
Patch672: patch-minios-ignore-close-0.patch
Patch673: patch-libvchan-Fix-cleanup-when-xc_gntshr_open-failed.patch
Patch674: patch-qemu-docs-utf8.patch
Patch675: patch-minios-remove-net-device-instead-of-preparing-for-re.patch
Patch676: patch-xenconsole-sanitize-ESC-in-log.patch
Patch677: patch-qemu-keyboard-leds.patch

Patch679: patch-0001-bitmap-fix-bitmap_fill-with-zero-sized-bitmap.patch
Patch680: patch-0002-drivers-video-drop-unused-limits.patch
Patch681: patch-0003-drivers-video-drop-framebuffer-size-constraints.patch
Patch682: patch-0004-drivers-video-use-vlfb_info-consistently.patch
Patch683: patch-0005-video-fix-handling-framebuffer-located-above-4GB.patch
Patch684: patch-xen-disable-efi-gettime.patch
Patch685: patch-libxl-console.patch
Patch686: patch-libxl-console-fix.patch
Patch687: patch-libxl-cleanup-remaining-backend-xs-dirs-after-driver.patch

# GCC7 fixes
Patch701: patch-0001-tools-include-sys-sysmacros.h-on-Linux.patch
Patch702: patch-tools-misc-xenlockprof-fix-possible-format-string-overflow.patch
Patch703: patch-v2-tools-fix-several-format-truncation-warnings-with-GCC-7.patch
Patch704: patch-stubdom-fix-vtpm-compilation-on-GCC-7.patch
Patch705: patch-vtpmmgr-make-inline-functions-static.patch
Patch706: patch-mini-os-link-to-libgcc.a-to-fix-build-with-gcc7.patch
# GCC8 fixes
Patch707: patch-0001-tools-libxc-fix-strncpy-size.patch
Patch708: patch-tools-misc-fix-hypothetical-buffer-overflow-in-xen-l.patch
Patch709: patch-tools-blktap2-fix-hypothetical-buffer-overflow.patch
Patch710: patch-tools-blktap2-fix-possible-0-truncation.patch
Patch711: patch-memfd-fix-configure-test.patch
Patch712: patch-tools-xenpmd-fix-possible-0-truncation.patch
Patch713: patch-tools-gdbsx-fix-Wstringop-truncation-warning.patch
Patch714: patch-tools-kdd-mute-spurious-gcc-warning.patch
# GCC9 fixes
Patch715: patch-xen.gcc9.fixes.patch
Patch716: patch-rombios-remove-packed-attribute-for-pushad_regs_t.patch

# GCC10 fixes
Patch717: patch-xen-gcc10-fixes.patch

# vchan for stubdom:
Patch801: patch-0100-minios-enhance-xenstore-available-for-stubdoms.patch
Patch802: patch-0101-libvchan-create-xenstore-entries-in-one-transaction.patch
Patch803: patch-0102-libvchan-remove-unnecessary-includes.patch
Patch804: patch-0103-minios-implement-gntalloc-interface.patch
Patch805: patch-0104-libxc-implement-gntshr-for-minios.patch
Patch806: patch-0105-stubdom-make-libvchan-available-in-stubdom.patch

# Qubes specific patches
Patch901: patch-stubdom-vbd-non-dom0-backend.patch
Patch902: patch-xen-no-downloads.patch
Patch903: patch-xen-hotplug-external-store.patch
Patch904: patch-xen-stubdom-qubes-gui.patch
Patch905: patch-stubdom-lwip-fix-for-dhcp.patch
Patch906: patch-xen-libxl-qubes-minimal-stubdom.patch
Patch907: patch-xen-disable-dom0-qemu.patch
Patch908: patch-libxl-disable-forced-vkb-for-HVM.patch
Patch909: patch-xenconsoled-enable-logging.patch
Patch910: patch-vm-0001-hotplug-do-not-attempt-to-remove-containing-xenstore.patch
Patch911: patch-xen-hotplug-qubesdb-update.patch
Patch912: patch-tools-hotplug-drop-perl-usage-in-locking-mechanism.patch
Patch913: patch-tools-xenconsole-replace-ESC-char-on-xenconsole-outp.patch
Patch914: patch-gnttab-disable-grant-tables-v2-by-default.patch

# python3
Patch1001: patch-0001-python-check-return-value-of-PyErr_NewException.patch
Patch1002: patch-0002-python-drop-tp_getattr-implementation.patch
Patch1003: patch-0003-python-use-Py_TYPE-instead-of-looking-directly-into-.patch
Patch1004: patch-0004-python-initialize-specific-fields-of-PyTypeObject.patch
Patch1005: patch-0005-python-use-PyBytes-PyUnicode-instead-of-PyString.patch
Patch1006: patch-0006-python-use-PyLong_-for-constructing-int-type-in-Pyth.patch
Patch1007: patch-0007-python-adjust-module-initalization-for-Python3.patch
Patch1008: patch-0008-python-handle-long-type-in-scripts.patch
# GCC9 fix, applied over python3
Patch1017: patch-python-fix-Wsign-compare-warnings.patch

# Support for Linux based stubdom
Patch1101: patch-stubdom-linux-0004.patch
Patch1102: patch-stubdom-linux-0005.patch
Patch1103: patch-stubdom-linux-0006.patch
Patch1104: patch-stubdom-linux-libxl-soname.patch
Patch1105: patch-stubdom-linux-pci-add-del.patch
Patch1106: patch-stubdom-linux-config-qubes-gui.patch
Patch1107: patch-stubdom-linux-fix-need-memory.patch
Patch1108: patch-stubdom-linux-config-stubdom-mem.patch
Patch1109: patch-stubdom-linux-libxl-suspend.patch
Patch1110: patch-stubdom-linux-libxl-silence-dm_check_start.patch
Patch1111: patch-stubdom-linux-libxl-do-not-force-qdisk-backend-for-cdrom.patch
Patch1112: patch-stubdom-linux-libxl-don-t-try-to-resolve-local-disk-path-with-stub.patch
Patch1113: patch-stubdom-allow-msi-irq.patch
Patch1114: patch-stubdom-allow-msi-enable.patch
Patch1115: patch-stubdom-linux-cmdline.patch
Patch1116: patch-xenstore-client-raw.patch

Patch1200: patch-fix-errors-on-ambiguous-python-shebang.patch
Patch1201: patch-xen-acpi-slic-support.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: transfig libidn-devel zlib-devel texi2html SDL-devel curl-devel
BuildRequires: libX11-devel ghostscript texlive-latex
%if %with_python2
BuildRequires: python2-devel
%endif
%if %with_python3
BuildRequires: python%{python3_pkgversion}-devel
%endif
%if 0%{?fedora} >= 18
BuildRequires: texlive-times texlive-courier texlive-helvetic texlive-ntgclass
%endif
BuildRequires: ncurses-devel gtk2-devel libaio-devel nettle-devel
# for the docs
BuildRequires: perl perl(Pod::Man) perl(Pod::Text) texinfo graphviz
# so that the makefile knows to install udev rules
BuildRequires: udev
%ifarch %{ix86} x86_64
# so that x86_64 builds pick up glibc32 correctly
BuildRequires: /usr/include/gnu/stubs-32.h
# for the VMX "bios"
BuildRequires: dev86
%endif
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: gettext
BuildRequires: glibc-devel
BuildRequires: gnutls-devel
BuildRequires: openssl-devel
# For ioemu PCI passthrough
BuildRequires: pciutils-devel
# Several tools now use uuid
BuildRequires: libuuid-devel
# iasl needed to build hvmloader
BuildRequires: iasl
# build using Fedora's ipxe package for roms
BuildRequires: ipxe-roms-qemu
# modern compressed kernels
BuildRequires: bzip2-devel xz-devel
# libfsimage
BuildRequires: e2fsprogs-devel
# tools now require yajl
BuildRequires: yajl-devel
# stubdom build requires cmake
BuildRequires: cmake
%if %with_xsm
# xsm policy file needs needs checkpolicy and m4
BuildRequires: checkpolicy m4
%endif
%if %build_crosshyp
# cross compiler for building 64-bit hypervisor on ix86
BuildRequires: gcc-x86_64-linux-gnu
%endif
# gcc with BTI mitigation, for dom0 build
%if 0%{?fedora} == 25
BuildRequires: gcc >= 6.4.1-1.qubes1
%endif
Requires: bridge-utils
%if 0%{?fedora} >= 29
Requires: python2-lxml
%else
Requires: python-lxml
%endif
Requires: udev >= 059
Requires: xen-runtime = %{version}-%{release}
# Not strictly a dependency, but kpartx is by far the most useful tool right
# now for accessing domU data from within a dom0 so bring it in when the user
# installs xen.
Requires: kpartx
Requires: chkconfig
ExclusiveArch: %{ix86} x86_64
#ExclusiveArch: %%{ix86} x86_64 ia64 noarch
%if %with_ocaml
BuildRequires: ocaml, ocaml-findlib
%endif
# efi image needs an ld that has -mi386pep option
%if %build_efi
BuildRequires: mingw64-binutils
%endif
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: systemd
BuildRequires: systemd-devel
# BIOS for HVMs
%if 0%{?rhel} >= 7
BuildRequires: OVMF
%else
BuildRequires: edk2-ovmf
%endif

%description
This package contains the XenD daemon and xm command line
tools, needed to manage virtual machines running under the
Xen hypervisor

%if %with_python2
%package -n python2-%{name}
Summary: Python2 bindings for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
Requires: python2
%{?python_provide:%python_provide python2-%{name}}

%description -n python2-%{name}
This package contains Python2 bindings to Xen tools. Especially xen.lowlevel.xs
and xen.lowlevel.xc modules.

%endif

%if %with_python3
%package -n python%{python3_pkgversion}-%{name}
Summary: Python3 bindings for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
Requires: python3
%{?python_provide:%python_provide python%{python3_pkgversion}-%{name}}

%description -n python%{python3_pkgversion}-%{name}
This package contains Python3 bindings to Xen tools. Especially xen.lowlevel.xs
and xen.lowlevel.xc modules.
%endif

%package libs
Summary: Libraries for Xen tools
Group: Development/Libraries
Requires(pre): /sbin/ldconfig
Requires(post): /sbin/ldconfig
Requires: xen-licenses
Provides: xen-libs = %{version}-%{release}
Obsoletes: xen-qubes-vm-libs < %{epoch}:%{version}-%{release}
# ifup/ifdown arguments dropped
Conflicts: xen-hvm-stubdom-linux < 1.0.10
# pvh definition syntax change
Conflicts: libvirt-daemon-driver-libxl < 3.3.0-7

%description libs
This package contains the libraries needed to run applications
which manage Xen virtual machines.


%package runtime
Summary: Core Xen runtime environment
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
# Ensure we at least have a suitable kernel installed, though we can't
# force user to actually boot it.
Requires: xen-hypervisor-abi = %{hv_abi}
Provides: xen-runtime = %{version}-%{release}

%description runtime
This package contains the runtime programs and daemons which
form the core Xen userspace environment.


%package hypervisor
Summary: Libraries for Xen tools
Group: Development/Libraries
Provides: xen-hypervisor-abi = %{hv_abi}
Requires: xen-licenses

%description hypervisor
This package contains the Xen hypervisor


%package doc
Summary: Xen documentation
Group: Documentation
#BuildArch: noarch
Requires: xen-licenses

%description doc
This package contains the Xen documentation.


%package devel
Summary: Development libraries for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
Requires: libuuid-devel
Provides: xen-devel = %{version}-%{release}

%description devel
This package contains what's needed to develop applications
which manage Xen virtual machines.


%package licenses
Summary: License files from Xen source
Group: Documentation

%description licenses
This package contains the license files from the source used
to build the xen packages.


%if %build_ocaml
%package ocaml
Summary: Ocaml libraries for Xen tools
Group: Development/Libraries
Requires: ocaml-runtime, xen-libs = %{version}-%{release}

%description ocaml
This package contains libraries for ocaml tools to manage Xen
virtual machines.


%package ocaml-devel
Summary: Ocaml development libraries for Xen tools
Group: Development/Libraries
Requires: xen-ocaml = %{version}-%{release}

%description ocaml-devel
This package contains libraries for developing ocaml tools to
manage Xen virtual machines.
%endif

%package hvm
Summary: Loader and device-model for HVM
Requires: xen-libs = %{version}-%{release}
Requires: xen-runtime = %{version}-%{release}

%description hvm
This package contains files for HVM domains, especially stubdomain with device model.

%package qemu-tools
Summary: Qemu disk tools bundled with Xen
Requires: xen-hvm = %{epoch}:%{version}-%{release}
Provides: qemu-img = 0.10.2
Conflicts: qemu-img

%description qemu-tools
This package contains symlinks to qemu tools (qemu-img, qemu-nbd, qemu-io)
budled with Xen, making them available for general use.

%package qubes-vm
Summary: Xen files required in Qubes VM
Requires: xen-libs = %{epoch}:%{version}-%{release}
Conflicts: xen
Provides: xen-qubes-vm-essentials = %{epoch}:%{version}-%{release}

%description qubes-vm
Just a few xenstore-* tools and Xen hotplug scripts needed by Qubes VMs

%prep
%autosetup -p1

# Fix for glibc 2.7
#FIXME sed 's:LIBS+=-lutil:LIBS+=-lutil -lrt:' -i tools/ioemu-qemu-xen/Makefile.target

# stubdom sources
cp -v %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} stubdom
cp -v %{SOURCE15} %{SOURCE16} %{SOURCE18} stubdom

# qubes specific parts of stubdom
tar xf %{SOURCE33}
mkdir tools/qubes-gui/
cp -a gui-agent-xen-hvm-stubdom/* tools/qubes-gui/

tar xf %{SOURCE36}
cp -a gui-common/include/qubes-gui*.h tools/qubes-gui/include/
make -C tools/qubes-gui clean

tar xf %{SOURCE34}
cp -a core-vchan-xen/vchan tools/
make -C tools/vchan -f Makefile.stubdom clean
sed -e 's/ioemu-qemu-xen/qemu-xen-traditional/g' tools/qubes-gui/gui-agent-qemu/qemu-glue.patch | patch -p1

tar xf %{SOURCE35}
cp -a stubdom-dhcp/* tools/qemu-xen-traditional/
patch -d tools/qemu-xen-traditional -p4 < stubdom-dhcp/lwip-dhcp-qemu-glue.patch


%build
%if !%build_ocaml
%define ocaml_flags OCAML_TOOLS=n
%endif
%if %build_efi
%define efi_flags LD_EFI=/usr/x86_64-w64-mingw32/bin/ld EFI_VENDOR=qubes
mkdir -p dist/install/boot/efi/efi/qubes
%endif
export XEN_VENDORVERSION="-%{release}"
export CFLAGS_EXTRA="$RPM_OPT_FLAGS"
export PATH="/usr/bin:$PATH"
export PYTHON=%{__python2}
export KCONFIG_CONFIG=%{SOURCE3}
cp -f %{SOURCE3} xen/.config
export XEN_CONFIG_EXPERT=y
autoreconf
make %{?_smp_mflags} %{?efi_flags} prefix=/usr dist-xen
# setting libexecdir to real libexec is broken in the configure script (it is
# overrided by /usr/lib)
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --libexecdir=/usr/lib \
    --with-system-seabios=/usr/lib/xen/boot/seabios-256k.bin \
    --with-system-ovmf=/usr/lib/xen/boot/ovmf.bin \
    --disable-vtpm-stubdom \
    --disable-vtpmmgr-stubdom \
    --with-extra-qemuu-configure-args="--disable-spice --disable-virtfs" \
    --disable-blktap2
make %{?_smp_mflags} %{?ocaml_flags} prefix=/usr debug_symbols=y dist-tools
make                 prefix=/usr dist-docs
unset CFLAGS
make %{?ocaml_flags} dist-stubdom

%if %with_python2
make PYTHON=%{__python2} -C tools/python
%endif
%if %with_python3
make PYTHON=%{__python3} -C tools/python
%endif

%install
export XEN_VENDORVERSION="-%{release}"
export CFLAGS_EXTRA="$RPM_OPT_FLAGS"
export PATH="/usr/bin:$PATH"
export KCONFIG_CONFIG=%{SOURCE3}
export XEN_CONFIG_EXPERT=y
rm -rf %{buildroot}
%if %build_ocaml
mkdir -p %{buildroot}%{_libdir}/ocaml/stublibs
%endif
%if %build_efi
mkdir -p %{buildroot}/boot/efi/efi/qubes
%endif
export PYTHON=%{__python2}
make DESTDIR=%{buildroot} %{?efi_flags}  prefix=/usr install-xen
make DESTDIR=%{buildroot} %{?ocaml_flags} prefix=/usr install-tools
make DESTDIR=%{buildroot} prefix=/usr install-docs
make DESTDIR=%{buildroot} %{?ocaml_flags} prefix=/usr install-stubdom
%if %build_efi
mv %{buildroot}/boot/efi/efi %{buildroot}/boot/efi/EFI
%endif
%if %build_xsm
# policy file should be in /boot/flask
mkdir %{buildroot}/boot/flask
mv %{buildroot}/boot/xenpolicy* %{buildroot}/boot/flask
%else
rm -f %{buildroot}/boot/xenpolicy*
rm -f %{buildroot}/usr/sbin/flask-*
%endif

%if %with_python2
make PYTHON=%{__python2} DESTDIR=%{buildroot} prefix=/usr -C tools/python install
%endif
%if %with_python3
make PYTHON=%{__python3} DESTDIR=%{buildroot} prefix=/usr -C tools/python install
%endif

# qemu symlinks
mkdir -p %{buildroot}/usr/bin
ln -s ../lib/%{name}/bin/qemu-img %{buildroot}/usr/bin/
ln -s ../lib/%{name}/bin/qemu-io  %{buildroot}/usr/bin/
ln -s ../lib/%{name}/bin/qemu-nbd %{buildroot}/usr/bin/

# "build" combined OVMF image based on system package
%if 0%{?rhel} >=7
cat /usr/share/OVMF/OVMF_{VARS,CODE.secboot}.fd > %{buildroot}/usr/lib/xen/boot/ovmf.bin
%else
cat /usr/share/edk2/ovmf/OVMF_{VARS,CODE}.fd > %{buildroot}/usr/lib/xen/boot/ovmf.bin
%endif

############ debug packaging: list files ############

find %{buildroot} -print | xargs ls -ld | sed -e 's|.*%{buildroot}||' > f1.list

############ kill unwanted stuff ############

# stubdom: newlib
rm -rf %{buildroot}/usr/*-xen-elf

# hypervisor symlinks
rm -rf %{buildroot}/boot/xen-4.7.gz
rm -rf %{buildroot}/boot/xen-4.gz
rm -rf %{buildroot}/boot/xen.gz
%if !%build_hyp
rm -rf %{buildroot}/boot
%endif

# silly doc dir fun
rm -rf %{buildroot}%{_datadir}/doc/xen
rm -rf %{buildroot}%{_datadir}/doc/qemu

# Pointless helper
rm -f %{buildroot}%{_sbindir}/xen-python-path

# qemu stuff (unused or available from upstream)
rm -rf %{buildroot}/usr/share/xen/man
for file in bios.bin openbios-sparc32 openbios-sparc64 ppc_rom.bin \
         pxe-e1000.bin pxe-ne2k_pci.bin pxe-pcnet.bin pxe-rtl8139.bin \
         vgabios.bin vgabios-cirrus.bin video.x openbios-ppc bamboo.dtb
do
    rm -f %{buildroot}/%{_datadir}/xen/qemu/$file
done
rm -f %{buildroot}/usr/libexec/qemu-bridge-helper

# README's not intended for end users
rm -f %{buildroot}/%{_sysconfdir}/xen/README*

# standard gnu info files
rm -rf %{buildroot}/usr/info

# adhere to Static Library Packaging Guidelines
rm -rf %{buildroot}/%{_libdir}/*.a

%if %build_efi
# clean up extra efi files
rm -rf %{buildroot}/%{_libdir}/efi
%endif

############ fixup files in /etc ############

# logrotate
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# init scripts
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xen-watchdog
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xencommons
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xendomains
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xendriverdomain
rm %{buildroot}%{_sysconfdir}/sysconfig/xendomains

cp %{SOURCE32} %{buildroot}/usr/lib/modules-load.d/xen.conf

# Qubes specific - get rid of standard domain starting scripts
rm %{buildroot}%{_unitdir}/xen-qemu-dom0-disk-backend.service
rm %{buildroot}%{_unitdir}/xendomains.service

############ create dirs in /var ############

mkdir -p %{buildroot}%{_localstatedir}/lib/xen/images
mkdir -p %{buildroot}%{_localstatedir}/log/xen/console

ln -s ../sbin/xl %{buildroot}/%{_bindir}/xl

############ debug packaging: list files ############

find %{buildroot} -print | xargs ls -ld | sed -e 's|.*%{buildroot}||' > f2.list
diff -u f1.list f2.list || true

############ assemble license files ############

mkdir licensedir
# avoid licensedir to avoid recursion, also stubdom/ioemu and dist
# which are copies of files elsewhere
find . -path licensedir -prune -o -path stubdom/ioemu -prune -o \
  -path dist -prune -o -name COPYING -o -name LICENSE | while read file; do
  mkdir -p licensedir/`dirname $file`
  install -m 644 $file licensedir/$file
done

############ all done now ############

%post runtime
%systemd_post xenstored.service xenconsoled.service

%preun runtime
%systemd_preun xenstored.service xenconsoled.service


%post qubes-vm
# Unconditionally enable this service in Qubes VM
systemctl enable xendriverdomain.service >/dev/null 2>&1 || :

%preun qubes-vm
%systemd_preun xendriverdomain.service

%post libs

/sbin/ldconfig

# reload libxl library
systemctl try-restart libvirtd.service >/dev/null 2>&1 || :

%postun libs -p /sbin/ldconfig

%if %build_hyp
%post hypervisor
%if %build_efi
EFI_DIR=$(efibootmgr -v 2>/dev/null | awk '
      /^BootCurrent:/ { current=$2; }
      /^Boot....\* / {
          if ("Boot" current "*" == $1) {
              sub(".*File\\(", "");
              sub("\\\\xen.efi\\).*", "");
              gsub("\\\\", "/");
              print;
          }
      }')
# FAT (on ESP) does not support symlinks
# override the file on purpose
if [ -d "/boot/efi${EFI_DIR}" ]; then
  cp -pf /boot/efi/EFI/qubes/xen-%{version}-%{release}.efi /boot/efi${EFI_DIR}/xen.efi
else
  cp -pf /boot/efi/EFI/qubes/xen-%{version}-%{release}.efi /boot/efi/EFI/qubes/xen.efi
fi
%endif

if [ -f /boot/efi/EFI/qubes/xen.cfg ]; then
    if ! grep -q smt=off /boot/efi/EFI/qubes/xen.cfg; then
        sed -i -e 's:^options=.*:\0 smt=off:' /boot/efi/EFI/qubes/xen.cfg
    fi
fi

if [ -f /etc/default/grub ]; then
    if ! grep -q smt=off /etc/default/grub; then
        echo 'GRUB_CMDLINE_XEN_DEFAULT="$GRUB_CMDLINE_XEN_DEFAULT smt=off"' >> /etc/default/grub
        grub2-mkconfig -o /boot/grub2/grub.cfg
    fi
fi

if [ $1 == 1 -a -f /sbin/grub2-mkconfig ]; then
  if [ -f /boot/grub2/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg
  fi
  if [ -f /boot/efi/EFI/qubes/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/efi/EFI/qubes/grub.cfg
  fi
fi

%postun hypervisor
if [ -f /sbin/grub2-mkconfig ]; then
  if [ -f /boot/grub2/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg
  fi
  if [ -f /boot/efi/EFI/qubes/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/efi/EFI/qubes/grub.cfg
  fi
fi
%endif

%if %build_ocaml
%post ocaml
%systemd_post oxenstored.service

%preun ocaml
%systemd_preun oxenstored.service
%endif

%clean
rm -rf %{buildroot}

# Base package only contains XenD/xm python stuff
#files -f xen-xm.lang
%files
%defattr(-,root,root)
%doc COPYING README
%{_bindir}/xencons

%files -n python2-%{name}
%{python2_sitearch}/%{name}
%{python2_sitearch}/xen-*.egg-info

%files -n python%{python3_pkgversion}-%{name}
%{python3_sitearch}/%{name}
%{python3_sitearch}/xen-*.egg-info

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*
%{_libdir}/fs

# All runtime stuff except for XenD/xm python stuff
%files runtime
%defattr(-,root,root)

%dir %attr(0700,root,root) %{_sysconfdir}/%{name}
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}/scripts/
%config %attr(0700,root,root) %{_sysconfdir}/%{name}/scripts/*

%{_sysconfdir}/bash_completion.d/xl.sh
%exclude %{_unitdir}/xendriverdomain.service

%{_unitdir}/proc-xen.mount
%{_unitdir}/var-lib-xenstored.mount
%{_unitdir}/xen-init-dom0.service
%{_unitdir}/xenstored.service
%{_unitdir}/xenconsoled.service
%{_unitdir}/xen-watchdog.service
/usr/lib/modules-load.d/xen.conf

%config(noreplace) %{_sysconfdir}/sysconfig/xencommons
%config(noreplace) %{_sysconfdir}/xen/xl.conf
%config(noreplace) %{_sysconfdir}/xen/cpupool
%config(noreplace) %{_sysconfdir}/xen/xlexample*

# Rotate console log files
%config(noreplace) %{_sysconfdir}/logrotate.d/xen

# Programs run by other programs
%dir /usr/lib/%{name}
%dir /usr/lib/%{name}/bin
# List them explicitly to exclude files owned by xen-hvm package
%attr(0700,root,root) /usr/lib/%{name}/bin/convert-legacy-stream
%attr(0700,root,root) /usr/lib/%{name}/bin/ivshmem-client
%attr(0700,root,root) /usr/lib/%{name}/bin/ivshmem-server
%attr(0700,root,root) /usr/lib/%{name}/bin/libxl-save-helper
%attr(0700,root,root) /usr/lib/%{name}/bin/lsevtchn
%attr(0700,root,root) /usr/lib/%{name}/bin/pygrub
%attr(0700,root,root) /usr/lib/%{name}/bin/readnotes
%attr(0700,root,root) /usr/lib/%{name}/bin/verify-stream-v2
%attr(0700,root,root) /usr/lib/%{name}/bin/xen-init-dom0
%attr(0700,root,root) /usr/lib/%{name}/bin/xenconsole
%attr(0700,root,root) /usr/lib/%{name}/bin/xenctx
%attr(0700,root,root) /usr/lib/%{name}/bin/xendomains
%attr(0700,root,root) /usr/lib/%{name}/bin/xenpvnetboot
# QEMU runtime files
%dir %{_datadir}/%{name}/qemu
%dir %{_datadir}/%{name}/qemu/keymaps
%{_datadir}/%{name}/qemu/keymaps/*
%dir %{_datadir}/qemu-xen
%dir %{_datadir}/qemu-xen/qemu
%{_datadir}/qemu-xen/qemu/*

# man pages
%{_mandir}/man1/xentop.1*
%{_mandir}/man1/xentrace_format.1*
%{_mandir}/man8/xentrace.8*
%{_mandir}/man1/xl.1*
%{_mandir}/man5/xl.cfg.5*
%{_mandir}/man5/xl.conf.5*
%{_mandir}/man5/xlcpupool.cfg.5*
%{_mandir}/man1/xenstore*

%{python2_sitearch}/fsimage.so
%{python2_sitearch}/grub
%{python2_sitearch}/pygrub-*.egg-info

# The firmware
%ifarch %{ix86} x86_64
%dir /usr/lib/%{name}/boot
/usr/lib/xen/boot/xenstore-stubdom.gz
/usr/lib/xen/boot/pv-grub*.gz
%endif
# General Xen state
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/lib/%{name}/dump
%dir %{_localstatedir}/lib/%{name}/images
# Xenstore persistent state
%dir %{_localstatedir}/lib/xenstored
# Xenstore runtime state
%ghost %{_localstatedir}/run/xenstored

# All xenstore CLI tools
%{_bindir}/qemu-*-xen
%{_bindir}/xenstore
%{_bindir}/xenstore-*
%{_bindir}/pygrub
%{_bindir}/xentrace*
/usr/lib/%{name}/bin/init-xenstore-domain
# XSM
%if %build_xsm
%{_sbindir}/flask-*
%endif
# Misc stuff
%{_bindir}/xen-detect
%{_bindir}/xencov_split
%{_sbindir}/gdbsx
%{_sbindir}/kdd
%{_sbindir}/xen-bugtool
%{_sbindir}/xen-hptool
%{_sbindir}/xen-hvmcrash
%{_sbindir}/xen-hvmctx
%{_sbindir}/xen-tmem-list-parse
%{_sbindir}/xenconsoled
%{_sbindir}/xenlockprof
%{_sbindir}/xenmon.py*
%{_sbindir}/xentop
%{_sbindir}/xentrace_setmask
%{_sbindir}/xenbaked
%{_sbindir}/xenstored
%{_sbindir}/xenpm
%{_sbindir}/xenpmd
%{_sbindir}/xenperf
%{_sbindir}/xenwatchdogd
%{_sbindir}/xl
%{_sbindir}/xen-lowmemd
%{_sbindir}/xen-ringwatch
%{_sbindir}/xencov
%{_sbindir}/xen-mfndump
%{_sbindir}/xen-livepatch
%{_bindir}/xen-cpuid
/usr/share/pkgconfig/*
%{_bindir}/xenalyze
%{_sbindir}/xentrace
%{_sbindir}/xentrace_setsize
%{_bindir}/xl

# Xen logfiles
%dir %attr(0700,root,root) %{_localstatedir}/log/xen
# Guest/HV console logs
%dir %attr(0700,root,root) %{_localstatedir}/log/xen/console

%files hypervisor
%if %build_hyp
%defattr(-,root,root)
/boot/xen-*.gz
%config(noreplace) /boot/xen-*.config
%if %build_xsm
%dir %attr(0755,root,root) /boot/flask
/boot/flask/xenpolicy*
%endif
%if %build_efi
/boot/efi/EFI/qubes/*.efi
%endif
/usr/lib/debug/xen*
%endif

%files doc
%defattr(-,root,root)
%doc docs/misc/
%doc dist/install/usr/share/doc/xen/html

%files devel
%defattr(-,root,root)
%{_includedir}/*.h
%dir %{_includedir}/xen
%{_includedir}/xen/*
%dir %{_includedir}/xenstore-compat
%{_includedir}/xenstore-compat/*
%{_libdir}/*.so

%files licenses
%defattr(-,root,root)
%doc licensedir/*

%if %build_ocaml
%files ocaml
%defattr(-,root,root)
%{_libdir}/ocaml/xen*
%exclude %{_libdir}/ocaml/xen*/*.a
%exclude %{_libdir}/ocaml/xen*/*.cmxa
%exclude %{_libdir}/ocaml/xen*/*.cmx
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner
%{_sbindir}/oxenstored
%config(noreplace) %{_sysconfdir}/xen/oxenstored.conf
%{_unitdir}/oxenstored.service

%files ocaml-devel
%defattr(-,root,root)
%{_libdir}/ocaml/xen*/*.a
%{_libdir}/ocaml/xen*/*.cmxa
%{_libdir}/ocaml/xen*/*.cmx
%endif

%files hvm
# The firmware
%ifnarch ia64
/usr/lib/%{name}/bin/stubdom-dm
/usr/lib/%{name}/bin/qemu-dm
/usr/lib/%{name}/bin/qemu-img
/usr/lib/%{name}/bin/qemu-io
/usr/lib/%{name}/bin/qemu-nbd
/usr/lib/%{name}/bin/qemu-system-i386
/usr/lib/%{name}/bin/stubdompath.sh
/usr/lib/%{name}/bin/xenpaging
# HVM loader is always in /usr/lib regardless of multilib
/usr/lib/xen/boot/hvmloader
/usr/lib/xen/boot/ioemu-stubdom.gz
/usr/lib/xen/boot/ovmf.bin
%endif

%files qemu-tools
/usr/bin/qemu-img
/usr/bin/qemu-io
/usr/bin/qemu-nbd
/usr/share/locale/*/LC_MESSAGES/qemu.mo

%files qubes-vm
%{_bindir}/xenstore
%{_bindir}/xenstore-*
%{_sbindir}/xl
%{_unitdir}/xendriverdomain.service
%config(noreplace) %{_sysconfdir}/xen/xl.conf

%dir %attr(0700,root,root) %{_sysconfdir}/xen
%dir %attr(0700,root,root) %{_sysconfdir}/xen/scripts/
%config %attr(0700,root,root) %{_sysconfdir}/xen/scripts/*

# General Xen state
%dir %{_localstatedir}/lib/xen
%dir %{_localstatedir}/lib/xen/dump

# Xen logfiles
%dir %attr(0700,root,root) %{_localstatedir}/log/xen

# Python modules
%dir %{python2_sitearch}/xen
%{python2_sitearch}/xen/__init__.*
%{python2_sitearch}/xen/lowlevel
%{python2_sitearch}/xen-*.egg-info


%changelog
* Tue Jul 05 2022 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-vmm-xen.git

* Tue Jul 05 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7593a9d
- version 4.8.5-42

* Tue Jul 05 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 75c9026
- Apply XSA-403 patch

* Fri Jun 17 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 94601e3
- version 4.8.5-41

* Thu Jun 16 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 471c439
- ci: do not override runner tags

* Thu Jun 16 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0c6af15
- Apply XSA-404 patches with dependencies

* Mon Jun 13 2022 Otto Sabart <seberm@seberm.com> - 4464a5c
- modules: use https instead of old git:// protocol

* Thu Jun 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d3530ac
- version 4.8.5-40

* Thu Jun 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b9486fc
- Apply XSA-401, XSA-402 patches

* Thu Jun 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 25dcaa6
- Backport patches necessary for upcoming XSA

* Tue Apr 05 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 62b51bd
- version 4.8.5-39

* Tue Apr 05 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6502412
- Apply XSA-399 and XSA-400 patches

* Wed Mar 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 85ce49c
- version 4.8.5-38

* Wed Mar 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bcdd0be
- Apply XSA-398 patch

* Thu Jan 20 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f1cd5e8
- version 4.8.5-37

* Thu Jan 20 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c103876
- Apply XSA-395

* Tue Nov 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3d9eabc
- version 4.8.5-36

* Tue Nov 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 33400a7
- Apply XSA-388, XSA-389 patches

* Tue Nov 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0e88263
- spec: shift patch number

* Tue Nov 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a7d61de
- Backport a patch prerequisite for XSA-388

* Wed Aug 25 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c6ebd5a
- version 4.8.5-35

* Wed Aug 25 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5eadaaa
- Disable grant tables v2

* Wed Aug 25 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 99bc941
- Adjust security fixes for Xen 4.8 and actually apply them

* Wed Aug 25 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ddc58be
- Commit unmodified Xen 4.11 patches for XSA-378, XSA-379

* Tue Jun 08 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e8571c3
- version 4.8.5-34

* Tue Jun 08 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3b8d464
- Apply XSAs patches: 373, 375, 377

* Tue Jun 08 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4f2aeb2
- Disable virtfs explicitly

* Thu Jun 03 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f5c3df7
- version 4.8.5-33

* Tue Jun 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ba4c0ac
- Add centos-stream to the makefile

* Sun May 16 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 32e0655
- version 4.8.5-32

* Sat May 15 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3a3c2f2
- Include Fedora in gitlab-ci too

* Sat May 15 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5dec501
- More GCC11 fixes

* Fri May 14 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ddfd43b
- version 4.8.5-31

* Fri May 14 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2237b59
- archlinux: drop python2-lxml dep

* Thu May 13 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4d30f15
- Backport patches fixing the build with GCC 11

* Thu Feb 18 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 809cfe3
- version 4.8.5-30

* Thu Feb 18 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a21a1c0
- Apply XSA-366 patch

* Sun Jan 03 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - feec44b
- version 4.8.5-29

* Sun Jan 03 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 10ae10c
- Cleanup parent xenstore dir after device remove

* Fri Jan 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 24f2fbc
- gitlab-ci: use separate exclude install list for dom0 and vm

* Fri Jan 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 49494d1
- archlinux: use autoreconf --install

* Fri Jan 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7e2a34e
- debian: update compat version to 10

* Thu Dec 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b69517e
- Add .gitlab-ci.yml

* Thu Dec 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7166707
- Fix patch-xen-gcc10-fixes.patch context, apply recent patches to deb too

* Tue Dec 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 04d4241
- version 4.8.5-28

* Tue Dec 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5ff332f
- Apply XSA-115 and XSA-325 patches

* Tue Dec 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 3bb54b4
- Backport a set of xenstore fixes

* Tue Nov 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 45f0084
- version 4.8.5-27

* Tue Nov 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f4347b0
- Apply XSA-355 patch

* Wed Nov 11 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0c9f31d
- version 4.8.5-26

* Wed Nov 11 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1dcc874
- Apply XSA-351 patches

